jersey.repackaged.org.objectweb.asm

## Class FieldVisitor

- java.lang.Object
- - jersey.repackaged.org.objectweb.asm.FieldVisitor

    public abstract class FieldVisitor
    extends Object

A visitor to visit a Java field. The methods of this class must be called in the following order: ( `visitAnnotation` | `visitTypeAnnotation` | `visitAttribute` )* `visitEnd`.

Author:
  Eric Bruneton

### Field Summary

Fields
`protected int` `api` The ASM API version implemented by this visitor.
`protected FieldVisitor` `fv` The field visitor to which this visitor must delegate method calls.

### Constructor Summary

Constructors
Constructor and Description
`FieldVisitor(int api)` Constructs a new `FieldVisitor`.
`FieldVisitor(int api, FieldVisitor fieldVisitor)` Constructs a new `FieldVisitor`.

### Method Summary

All Methods Instance Methods Concrete Methods
`AnnotationVisitor` `visitAnnotation(String descriptor, boolean visible)` Visits an annotation of the field.
`void` `visitAttribute(Attribute attribute)` Visits a non standard attribute of the field.
`void` `visitEnd()` Visits the end of the field.
`AnnotationVisitor` `visitTypeAnnotation(int typeRef, TypePath typePath, String descriptor, boolean visible)` Visits an annotation on the type of the field.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### api

    protected final int api

The ASM API version implemented by this visitor. The value of this field must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6`, `Opcodes.ASM7`, `Opcodes.ASM8` or `Opcodes.ASM9`.

#### fv

    protected FieldVisitor fv

The field visitor to which this visitor must delegate method calls. May be null.

### Constructor Detail

#### FieldVisitor

    public FieldVisitor(int api)

Constructs a new `FieldVisitor`.

Parameters:
  `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6`, `Opcodes.ASM7`, `Opcodes.ASM8` or `Opcodes.ASM9`.

#### FieldVisitor

    public FieldVisitor(int api,
                        FieldVisitor fieldVisitor)

Constructs a new `FieldVisitor`.

Parameters:
  `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4`, `Opcodes.ASM5`, `Opcodes.ASM6`, `Opcodes.ASM7` or `Opcodes.ASM8`.
  `fieldVisitor` - the field visitor to which this visitor must delegate method calls. May be null.

### Method Detail

#### visitAnnotation

    public AnnotationVisitor visitAnnotation(String descriptor,
                                             boolean visible)

Visits an annotation of the field.

Parameters:
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

#### visitTypeAnnotation

    public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                                 TypePath typePath,
                                                 String descriptor,
                                                 boolean visible)

Visits an annotation on the type of the field.

Parameters:
  `typeRef` - a reference to the annotated type. The sort of this type reference must be `TypeReference.FIELD`. See `TypeReference`.
  `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole.
  `descriptor` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

#### visitAttribute

    public void visitAttribute(Attribute attribute)

Visits a non standard attribute of the field.

Parameters:
  `attribute` - an attribute.

#### visitEnd

    public void visitEnd()

Visits the end of the field. This method, which is the last one to be called, is used to inform the visitor that all the annotations and attributes of the field have been visited.